package org.processmining.visualisation3d;

import java.util.HashMap;
import java.util.Set;

public class JoglResourceManager 
{
	private static HashMap<String, JoglResourcePointer> resources = new HashMap<String, JoglResourcePointer>();
	
	public static Set<String> GetResourceNames()
	{
		return resources.keySet();
	}
	
	public static void AddResource(String resName, Object o)
	{
		if (resources.containsKey(resName))
		{
			resources.get(resName).SetResource(o);
		}
		else
		{
			resources.put(resName, new JoglResourcePointer(resName, o));
		}
	}
	
	public static boolean HasResource(String resName)
	{
		return resources.containsKey(resName);
	}
	
	public static Object GetResource(String resName)
	{
		if (resources.containsKey(resName))
		{
			return resources.get(resName).GetResource();
		}
		return null;
	}
	
	public static void ClearResources()
	{
		resources.clear();
	}
}
