package org.processmining.visualisation3d;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import org.processmining.visualisation3d.input.JoglInputMouseEvent;
import org.processmining.visualisation3d.input.JoglInputMouseWheelEvent;

public class MouseInputArea implements MouseListener, MouseMotionListener, MouseWheelListener
{
	private JoglPanel panel;
	
	public IMouseProcessor proc = null;
	
	public MouseInputArea(JoglPanel p)
	{
		panel = p;
	}
	 
	//MouseListener method implementation
	@Override
	public void mouseClicked(MouseEvent e)
	{
		//System.out.println(interactions.printStack());
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mouseClicked(jime);
		}
	}

	@Override
	public void mouseEntered(MouseEvent e)
	{
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mouseEntered(jime);
		}
	}

	@Override
	public void mouseExited(MouseEvent e)
	{
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mouseExited(jime);
		}
	}

	@Override
	public void mousePressed(MouseEvent e)
	{
		//System.out.println("mouse pressed: " + e.getButton());
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mousePressed(jime);
		}
	}

	@Override
	public void mouseReleased(MouseEvent e)
	{
		//System.out.println("mouse released: " + e.getButton());
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mouseReleased(jime);
		}

	}

	@Override
	public void mouseMoved(MouseEvent e)
	{
		//System.out.println("mouse moved");
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mouseMoved(jime);
		}
	}

	@Override
	public void mouseDragged(MouseEvent e)
	{
		//System.out.println("mouse dragged");
		if (proc != null)
		{
			JoglInputMouseEvent jime = new JoglInputMouseEvent(e);
			jime.scalePoint(panel.getWidth(), panel.getHeight());
			proc.mouseDragged(jime);
		}
	}

	@Override
	public void mouseWheelMoved(MouseWheelEvent e)
	{
		//System.out.println("mouse wheel moved");
		if (proc != null)
		{
			JoglInputMouseWheelEvent jimwe = new JoglInputMouseWheelEvent(e);
			proc.mouseWheelMoved(jimwe);
		}
	}

}
