package org.processmining.visualisation3d;

public class PipelineState
{
	protected GraphicsPipeline pipe = null;

	protected static BlendMode currentBlendMode = BlendMode.Opaque;
	protected static CullState currentCullState = CullState.CullNone;
	protected static MaskState currentMaskState = MaskState.DrawBoth;
	protected static boolean bDepthTest = true;

	public enum CullState 
	{
		CullNone, 
		CullBack, 
		CullFront, 
		CullBoth
	}
	
	public enum MaskState 
	{
		DrawNone, 
		DrawDepthOnly, 
		DrawColorOnly, 
		DrawBoth
	}
	
	public enum BlendMode 
	{
		Opaque, 
		AlphaBlended
	}
	
	public PipelineState()
	{
		super();
	}

	public void Apply(GraphicsPipeline pipe)
	{
		this.pipe = pipe;
	}
	
	public void Unapply(GraphicsPipeline pipe)
	{
		this.pipe = pipe;
	}

}