package org.processmining.visualisation3d.graphicsdatastructures;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.JoglVertexArrayObjectBuffer;
import org.processmining.visualisation3d.maths.JoglVectord3;
import org.processmining.visualisation3d.maths.JoglVectord3Buffer;

import com.jogamp.opengl.GL2;

public class JoglMeshDataBufferVectord3 extends JoglVectord3Buffer implements IJoglMeshDataBuffer
{
	public JoglMeshDataBufferVectord3()
	{
		
	}
	
	public JoglMeshDataBufferVectord3(int vCapacity)
	{
		super(vCapacity);
	}
	
	public JoglVertexArrayObjectBuffer getVAOBuffer(GraphicsPipeline pipe) 
	{
		vertsd.rewind();
		
		JoglVertexArrayObjectBuffer posbuf = new JoglVertexArrayObjectBuffer(pipe, JoglVectord3.class, true);
        posbuf.Bind(pipe);
        posbuf.SetData(pipe.gl, vertsd);
        posbuf.Unbind(pipe);
        
		return posbuf;
	}
	
	@Override
	public void drawNextVertex3d(GL2 gl)
	{
		gl.glVertex3d(vertsd.get(), vertsd.get(), vertsd.get());
	}

	@Override
	public void drawNextColor3d(GL2 gl)
	{
		gl.glColor3d(vertsd.get(), vertsd.get(), vertsd.get());
	}

	@Override
	public void drawNextNormal3d(GL2 gl)
	{
		gl.glNormal3d(vertsd.get(), vertsd.get(), vertsd.get());
	}
	
	@Override
	public void drawNextTexCoord2d(GL2 gl)
	{
	}
}
