package org.processmining.visualisation3d.graphicsdatastructures;

import java.awt.Dimension;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.maths.JoglVectord3;

import com.jogamp.opengl.GL;

public class JoglRenderTarget 
{
	protected float backgroundR = 0;
	protected float backgroundG = 0;
	protected float backgroundB = 0;

	public void setBackgroundColor(float r, float g, float b)
	{
		backgroundR = r;
		backgroundG = g;
		backgroundB = b;
	}
	
	public void setBackgroundColor(JoglVectord3 col)
	{
		backgroundR = (float)col.getX();
		backgroundG = (float)col.getY();
		backgroundB = (float)col.getZ();
	}
	
	public int getWidth()
	{
		return 0;
	}
	
	public int getHeight()
	{
		return 0;
	}
	
	public double getAspect()
	{
		return (double)getWidth() / (double)getHeight();
	}
	
	public Dimension getSize()
	{
		return new Dimension(getWidth(), getHeight());
	}
	
	public void FitViewport(GraphicsPipeline pipe)
	{
		pipe.gl.glViewport(0, 0, getWidth(), getHeight());
	}
	
	public void Bind(GraphicsPipeline pipe)
	{
		pipe.gl.glClearColor(backgroundR, backgroundG, backgroundB, 0.0f);
		pipe.gl.glClearDepth(1.0f);
	}
	
	public void Unbind(GraphicsPipeline pipe)
	{
		
	}
	
	public void Clear(GraphicsPipeline pipe)
	{
		pipe.gl.glClear(GL.GL_COLOR_BUFFER_BIT);
		pipe.gl.glClear(GL.GL_DEPTH_BUFFER_BIT);
	}
}
