package org.processmining.visualisation3d.graphicsdatastructures;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.gldatastructures.IJoglFrameBufferObject;

public class JoglRenderTargetFramebuffer extends JoglRenderTarget
{
	private IJoglFrameBufferObject myTarget;
	
	@Override
	public int getWidth()
	{
		return myTarget.getWidth();
	}

	@Override
	public int getHeight()
	{
		return myTarget.getHeight();
	}
	
	public JoglRenderTargetFramebuffer(IJoglFrameBufferObject drawable)
	{
		myTarget = drawable;
	}

	@Override
	public void Bind(GraphicsPipeline pipe)
	{
		pipe.gl.glClearColor(backgroundR, backgroundG, backgroundB, 0.0f);
		pipe.gl.glClearDepth(1.0f);
		
		myTarget.Bind(pipe);
	}

	@Override
	public void Unbind(GraphicsPipeline pipe)
	{
		myTarget.Unbind(pipe);
	}
}
