package org.processmining.visualisation3d.graphicsdatastructures;

import org.processmining.visualisation3d.GraphicsPipeline;
import org.processmining.visualisation3d.settings.JoglGraphicsSettings;

import com.jogamp.opengl.GL;
import com.jogamp.opengl.GLAutoDrawable;

public class JoglRenderTargetGLCanvas extends JoglRenderTarget
{
	private GLAutoDrawable myTarget;
	
	@Override
	public int getWidth()
	{
		return myTarget.getSurfaceWidth();
	}

	@Override
	public int getHeight()
	{
		return myTarget.getSurfaceHeight();
	}
	
	public JoglRenderTargetGLCanvas(GLAutoDrawable drawable)
	{
		myTarget = drawable;
	}

	@Override
	public void Bind(GraphicsPipeline pipe)
	{
		pipe.gl.glClearColor(backgroundR, backgroundG, backgroundB, 0.0f);
		pipe.gl.glClearDepth(1.0f);
		
		if (JoglGraphicsSettings.SupportsFramebufferObjects(pipe))
		{
			pipe.gl.glBindFramebuffer(GL.GL_FRAMEBUFFER, 0);
		}
	}

	@Override
	public void Unbind(GraphicsPipeline pipe)
	{
		
	}
}
