package org.processmining.visualisation3d.gui;

import java.util.Iterator;
import java.util.Vector;

public class JoglGuiObjectCollection implements Iterable<JoglGuiObject>
{
	private Vector<JoglGuiObject> guiObjs = new Vector<JoglGuiObject>();

	public void add(JoglGuiObject jgo)
	{
		//sort objects in collection by zlevel value
		for (int i = 0; i < guiObjs.size(); i++)
		{
			if (jgo.getZLevel() < guiObjs.get(i).getZLevel())
			{
				guiObjs.insertElementAt(jgo, i);
				return;
			}
		}
		
		//if not inserted before existing element add as last element
		guiObjs.add(jgo);
	}
	
	public JoglGuiObject get(int i)
	{
		return guiObjs.get(i);
	}
	
	public void remove(JoglGuiObject jgo)
	{
		guiObjs.remove(jgo);
	}
	
	public int size()
	{
		return guiObjs.size();
	}

	public Iterator<JoglGuiObject> iterator() 
	{
		return guiObjs.iterator();
	}
}
