package org.processmining.visualisation3d.input;

import java.awt.event.MouseEvent;

import org.processmining.visualisation3d.maths.JoglVectord2;

public class JoglInputMouseEvent extends JoglInputEvent 
{
	private int button = -1;
	private JoglVectord2 point;
	
	private boolean control = false;
	private boolean shift = false;
	
	public JoglInputMouseEvent(MouseEvent evt)
	{
		button = evt.getButton();
		point = new JoglVectord2(evt.getPoint().x, evt.getPoint().y);
		
		control = evt.isControlDown();
		shift = evt.isShiftDown();
	}
	
	public void scalePoint(double width, double height)
	{
		point = new JoglVectord2(point.getX() / width, point.getY() / height);
	}
	
	public int getButton()
	{
		return button;
	}
	
	public JoglVectord2 getPoint()
	{
		return point;
	}
	
	public double getX()
	{
		return point.getX();
	}
	
	public double getY()
	{
		return point.getY();
	}
	
	public boolean isControlDown()
	{
		return control;
	}
	
	public boolean isShiftDown()
	{
		return shift;
	}
}
