package org.processmining.visualisation3d.interactions;

import org.processmining.visualisation3d.JoglInteraction;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCamera;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCameraLensOrthographic;
import org.processmining.visualisation3d.graphicsdatastructures.JoglCameraLensPerspective;
import org.processmining.visualisation3d.input.JoglInputDisplaySizeChangedEvent;

public class JICameraBase extends JoglInteraction 
{
	protected JoglCamera cam;
	
	public JoglCamera getCamera()
	{
		return cam;
	}
	
	public JICameraBase(JoglCamera c)
	{
		cam = c;
	}
	
	public boolean bUseOrtho = false;
	
	public void UpdateCameraLens(double aspect)
	{
		if (bUseOrtho)
		{
			cam.setCameraLens(new JoglCameraLensOrthographic(aspect));
		}
		else
		{
			cam.setCameraLens(new JoglCameraLensPerspective(45.0, aspect));
		}
	}
	
	@Override
	public void displaySizeChanged(JoglInputDisplaySizeChangedEvent e)
	{
		UpdateCameraLens((double)e.getWidth() / (double)e.getHeight());
	}
}
