package org.processmining.visualisation3d.materials;

import org.processmining.visualisation3d.GraphicsPipeline;

public class MaterialGuiBase extends JoglMaterial
{
	private boolean oldDepthTest = true;
	private MaskState oldMaskState = MaskState.DrawBoth;
	
	public MaterialGuiBase()
	{
	}

	@Override
	public void Apply(GraphicsPipeline pipe)
	{
		super.Apply(pipe);

		oldDepthTest = bDepthTest;
		oldMaskState = currentMaskState;
		
		setDepthTest(false);
		setMaskState(MaskState.DrawColorOnly);
	}

	@Override
	public void Unapply(GraphicsPipeline pipe)
	{
		super.Unapply(pipe);

		setMaskState(oldMaskState);
		setDepthTest(oldDepthTest);
	}
}
