package org.processmining.visualisation3d.maths;

public class JoglColor3 extends JoglVectord3 
{
	public static JoglVectord3 BLACK = new JoglVectord3(0.0, 0.0, 0.0);
	public static JoglVectord3 WHITE = new JoglVectord3(1.0, 1.0, 1.0);
	public static JoglVectord3 RED = new JoglVectord3(1.0, 0.0, 0.0);
	public static JoglVectord3 GREEN = new JoglVectord3(0.0, 1.0, 0.0);
	public static JoglVectord3 BLUE = new JoglVectord3(0.0, 0.0, 1.0);
	public static JoglVectord3 YELLOW = new JoglVectord3(1.0, 1.0, 0.0);
	public static JoglVectord3 CYAN = new JoglVectord3(0.0, 1.0, 1.0);
	public static JoglVectord3 MAGENTA = new JoglVectord3(1.0, 0.0, 1.0);
	public static JoglVectord3 GRAY = new JoglVectord3(0.5, 0.5, 0.5);
	public static JoglVectord3 DARKGRAY = new JoglVectord3(0.25, 0.25, 0.25);
	public static JoglVectord3 LIGHTGRAY = new JoglVectord3(0.75, 0.75, 0.75);
	
	public JoglVectord3 AlphaBlend(JoglVectord3 c1, JoglVectord3 c2, double srcAlpha)
	{
		JoglVectord3 res1 = JoglVectord3.Multiply(c1, srcAlpha);
		JoglVectord3 res2 = JoglVectord3.Multiply(c2, 1.0 - srcAlpha);
		JoglVectord3 res3 = JoglVectord3.Add(res1, res2);
		
		//System.out.println("Color mix: " + res3.toString());
		return res3;
	}
}
