package org.processmining.visualisation3d.maths;

public class JoglColor4 extends JoglVectord4 
{
	public static JoglVectord4 BLACK = new JoglVectord4(0.0, 0.0, 0.0, 1.0);
	public static JoglVectord4 WHITE = new JoglVectord4(1.0, 1.0, 1.0, 1.0);
	public static JoglVectord4 RED = new JoglVectord4(1.0, 0.0, 0.0, 1.0);
	public static JoglVectord4 GREEN = new JoglVectord4(0.0, 1.0, 0.0, 1.0);
	public static JoglVectord4 BLUE = new JoglVectord4(0.0, 0.0, 1.0, 1.0);
	public static JoglVectord4 YELLOW = new JoglVectord4(1.0, 1.0, 0.0, 1.0);
	public static JoglVectord4 CYAN = new JoglVectord4(0.0, 1.0, 1.0, 1.0);
	public static JoglVectord4 MAGENTA = new JoglVectord4(1.0, 0.0, 1.0, 1.0);
	public static JoglVectord4 GRAY = new JoglVectord4(0.5, 0.5, 0.5, 1.0);
	public static JoglVectord4 DARKGRAY = new JoglVectord4(0.25, 0.25, 0.25, 1.0);
	public static JoglVectord4 LIGHTGRAY = new JoglVectord4(0.75, 0.75, 0.75, 1.0);
	
	public JoglVectord4 AlphaBlend(JoglVectord4 c1, JoglVectord4 c2)
	{
		double srcAlpha = c1.getValue(3);
		
		JoglVectord4 res1 = JoglVectord4.Multiply(c1, srcAlpha);
		JoglVectord4 res2 = JoglVectord4.Multiply(c2, 1.0 - srcAlpha);
		JoglVectord4 res3 = JoglVectord4.Add(res1, res2);
		
		//System.out.println("Color mix: " + res3.toString());
		return res3;
	}
}
