package org.processmining.visualisation3d.maths;

import java.util.Vector;

public class JoglColorGradient 
{
	private Vector<JoglVectord3> colors = new Vector<JoglVectord3>();
	
	public void addColor(JoglVectord3 c)
	{
		colors.add(c);
	}
	
	public JoglVectord3 getColorAt(double mix)
	{
		double test = mix * (colors.size() - 1);
		int a = (int)(Math.floor(test));
		double b = test - (double)a;
		
		JoglVectord3 col1 = colors.get(a);
		JoglVectord3 col2 = colors.get(Math.min(a + 1, colors.size() - 1));
		
		return JoglVectord3.Blend(col1, col2, (float)b);
	}
}
