package org.processmining.visualisation3d.maths;

public class JoglLine 
{
	//get point on first line, that is closest to second line
	public static JoglVectord3 GetClosestPoint(JoglVectord3 p0, JoglVectord3 d0, JoglVectord3 p1, JoglVectord3 d1)
	{
		double sc = GetClosestPointDist(p0, d0, p1, d1);
		//double tc = ((a * e) - (b * d)) / ((a * c) - (b * b));
		
		return JoglVectord3.Add(p0, JoglVectord3.Multiply(d0, sc));
	}
	
	public static double GetClosestPointDist(JoglVectord3 p0, JoglVectord3 d0, JoglVectord3 p1, JoglVectord3 d1)
	{
		JoglVectord3 w = JoglVectord3.Subtract(p0, p1);
		
		//double a = JoglVectord3.Dot(d0, d0);
		double b = JoglVectord3.Dot(d0, d1);
		//double c = JoglVectord3.Dot(d1, d1);
		double d = JoglVectord3.Dot(d0, w);
		double e = JoglVectord3.Dot(d1, w);
		
		//System.out.println("A: " + a);
		//System.out.println("C: " + c);
		
		double sc = ((b * e) - (1.0 * d)) / ((1.0) - (b * b)); // = ((b * e) - (c * d)) / ((a * c) - (b * b));
		//double tc = ((a * e) - (b * d)) / ((a * c) - (b * b));
		
		return sc;
	}
	
	public static double GetClosestDistance(JoglVectord3 p0, JoglVectord3 d0, JoglVectord3 p1, JoglVectord3 d1)
	{
		JoglVectord3 w = JoglVectord3.Subtract(p0, p1);
		
		//JoglVectord3 a = GetClosestPoint(p0, d0, p1, d1);
		//JoglVectord3 b = GetClosestPoint(p1, d1, p0, d0);

		//double a = JoglVectord3.Dot(d0, d0);
		double b = JoglVectord3.Dot(d0, d1);
		//double c = JoglVectord3.Dot(d1, d1);
		double d = JoglVectord3.Dot(d0, w);
		double e = JoglVectord3.Dot(d1, w);
		double x = ((1.0) - (b * b)); //= ((a * c) - (b * b));
		
		double sc = ((b * e) - (1.0 * d)) / x; //= ((b * e) - (c * d)) / x;
		double tc = ((1.0 * e) - (b * d)) / x; //= ((a * e) - (b * d)) / x;

		JoglVectord3 av = JoglVectord3.Add(p0, JoglVectord3.Multiply(d0, sc));
		JoglVectord3 bv = JoglVectord3.Add(p1, JoglVectord3.Multiply(d1, tc));
		
		return JoglVectord3.Distance(av, bv);
	}
}
