package org.processmining.visualisation3d.maths;

public class JoglMatrixd
{
	private double[] data;
	private int rows;
	private int cols;
	
	
	public JoglMatrixd(int rows, int cols)
	{
		this.rows = rows;
		this.cols = cols;
		
		data = new double[rows * cols];
	}
	
	public double[] GetData()
	{
		return data;
	}
	
	public void SetData(double[] d)
	{
		data = d;
	}
	
	public double GetValue(int r, int c)
	{
		return data[(c * rows) + r];
	}
	
	public void SetValue(int r, int c, double v)
	{
		data[(c * rows) + r] = v;
	}

	public static JoglMatrixd Multiply(JoglMatrixd m1, JoglMatrixd m2)
	{
    	JoglMatrixd nm = new JoglMatrixd(m1.rows, m2.cols);

        for (int j = 0; j < m1.rows; j++)
        {
            for (int i = 0; i < m2.cols; i++)
            {
                for (int k = 0; k < m2.rows; k++)
                {
                    nm.SetValue(j, i, nm.GetValue(j, i) + m1.GetValue(j, k) * m2.GetValue(k, i));
                }
            }
        }
        
    	return nm;
	}

	public static JoglMatrixd Multiply(JoglMatrixd m1, double d)
	{
    	JoglMatrixd nm = new JoglMatrixd(m1.rows, m1.cols);

        for (int i = 0; i < m1.cols; i++)
        {
            for (int j = 0; j < m1.rows; j++)
            {
                nm.SetValue(j, i, m1.GetValue(j, i) * d);
            }
        }
        
    	return nm;
	}
	
    public static JoglMatrixd CreateTranspose(JoglMatrixd om)
    {
    	JoglMatrixd nm = new JoglMatrixd(om.cols, om.rows);

        for (int j = 0; j < om.rows; j++)
        {
            for (int i = 0; i < om.cols; i++)
            {
                nm.SetValue(i, j, om.GetValue(j,i));
            }
        }

        return nm;
    }
}
