package org.processmining.visualisation3d.maths;

import java.nio.DoubleBuffer;
import java.util.Vector;

//import org.processmining.processprofiler3d.compviz.graphicsdatastructures.JoglTexturedMesh;

import com.jogamp.common.nio.Buffers;

public class JoglVectord2Buffer 
{
	protected DoubleBuffer texCoordsd;
	
	public JoglVectord2Buffer()
	{
		texCoordsd = Buffers.newDirectDoubleBuffer(2);
		texCoordsd.limit(0);
	}
	
	public JoglVectord2Buffer(int vCapacity)
	{
		texCoordsd = Buffers.newDirectDoubleBuffer(vCapacity * 2);
		texCoordsd.limit(0);
	}
	
	public double[] getArray()
	{
		double[] dst = new double[texCoordsd.limit()];
		texCoordsd.position(0);
		texCoordsd.get(dst, 0, texCoordsd.limit());
		
		return dst;
	}
	
	public DoubleBuffer getNativeBuffer()
	{
		return texCoordsd;
	}
	
	public void position(int pos)
	{
		texCoordsd.position(pos * 2);
	}
	
	public void set(double[] tclist)
	{
		int newCap = tclist.length;

		if (newCap > texCoordsd.capacity())
		{
			texCoordsd = Buffers.newDirectDoubleBuffer(tclist);
		}
		else
		{
			texCoordsd.position(0);
			texCoordsd.limit(newCap);
			texCoordsd.put(tclist);
		}
	}
	
	public void set(Vector<JoglVectord2> tclist)
	{
		int newCap = tclist.size() * 2;
		if (newCap > texCoordsd.capacity())
		{
			texCoordsd = Buffers.newDirectDoubleBuffer(newCap);
			
			for (int i = 0; i < tclist.size(); i++)
			{
				JoglVectord2 v = tclist.get(i);
				texCoordsd.put(v.getData());
			}
		}
		else
		{
			texCoordsd.limit(newCap);
			for (int i = 0; i < tclist.size(); i++)
			{
				JoglVectord2 v = tclist.get(i);
				texCoordsd.put(v.getData());
			}
		}
	}
	
	public void add(double[] tclist)
	{
		int oldCap = texCoordsd.limit();
		int newCap = oldCap + tclist.length;

		if (newCap > texCoordsd.capacity())
		{
			DoubleBuffer ntexCoordsd = Buffers.newDirectDoubleBuffer(newCap);
			
			//copy old verts
			texCoordsd.position(0);
			ntexCoordsd.put(texCoordsd);
	
			ntexCoordsd.put(tclist);
			
			texCoordsd = ntexCoordsd;
		}
		else
		{
			texCoordsd.limit(newCap);
			texCoordsd.put(tclist);
		}
	}
	
	public void add(Vector<JoglVectord2> tclist)
	{
		int oldCap = texCoordsd.limit();
		int newCap = oldCap + (tclist.size() * 2);

		if (newCap > texCoordsd.capacity())
		{
			DoubleBuffer ntexCoordsd = Buffers.newDirectDoubleBuffer(newCap);
			
			//copy old verts
			texCoordsd.position(0);
			ntexCoordsd.put(texCoordsd);
			
			for (int i = 0; i < tclist.size(); i++)
			{
				JoglVectord2 v = tclist.get(i);
				ntexCoordsd.put(v.getData());
			}
			
			texCoordsd = ntexCoordsd;
		}
		else
		{
			texCoordsd.limit(newCap);
			for (int i = 0; i < tclist.size(); i++)
			{
				JoglVectord2 v = tclist.get(i);
				texCoordsd.put(v.getData());
			}
		}
	}
	
	public void add(DoubleBuffer tclist)
	{
		int oldCap = texCoordsd.limit();
		int newCap = oldCap + tclist.limit();

		if (newCap > texCoordsd.capacity())
		{
			DoubleBuffer ntexCoordsd = Buffers.newDirectDoubleBuffer(newCap);
			
			//copy old verts
			texCoordsd.position(0);
			ntexCoordsd.put(texCoordsd);
	
			tclist.position(0);
			ntexCoordsd.put(tclist);
			
			texCoordsd = ntexCoordsd;
		}
		else
		{
			tclist.position(0);
			texCoordsd.limit(newCap);
			texCoordsd.put(tclist);
		}
	}
	
//	public void add(JoglTexturedMesh m)
//	{
//		DoubleBuffer tclist = m.getTexCoordsBuffer();
//		int oldCap = texCoordsd.limit();
//		int newCap = oldCap + tclist.limit();
//
//		if (newCap > texCoordsd.capacity())
//		{
//			DoubleBuffer ntexCoordsd = Buffers.newDirectDoubleBuffer(newCap);
//			
//			//copy old verts
//			texCoordsd.position(0);
//			ntexCoordsd.put(texCoordsd);
//	
//			tclist.position(0);
//			ntexCoordsd.put(tclist);
//			
//			texCoordsd = ntexCoordsd;
//		}
//		else
//		{
//			tclist.position(0);
//			texCoordsd.limit(newCap);
//			texCoordsd.put(tclist);
//		}
//	}
	
//	public void drawNextTexCoord2d(GL2 gl)
//	{
//		gl.glTexCoord2d(texCoordsd.get(), texCoordsd.get());
//	}

}

